
/* **************************************************************************

  $Archive: /njcl_v2rmi/src/com/novell/service/nds/naming/local/NCPServerDirContext.java $
  $Revision: 8 $
  $Modtime: 11/15/00 3:43p $
 
  Copyright (c) 1998 Novell, Inc.  All Rights Reserved.

  THIS WORK IS  SUBJECT  TO  U.S.  AND  INTERNATIONAL  COPYRIGHT  LAWS  AND
  TREATIES.   NO  PART  OF  THIS  WORK MAY BE  USED,  PRACTICED,  PERFORMED
  COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,  ABRIDGED, CONDENSED,
  EXPANDED,  COLLECTED,  COMPILED,  LINKED,  RECAST, TRANSFORMED OR ADAPTED
  WITHOUT THE PRIOR WRITTEN CONSENT OF NOVELL, INC. ANY USE OR EXPLOITATION
  OF THIS WORK WITHOUT AUTHORIZATION COULD SUBJECT THE PERPETRATOR TO
  CRIMINAL AND CIVIL LIABILITY.

****************************************************************************/

package com.novell.service.nds.naming.local;


import java.io.Serializable;

import java.util.Date;
import java.util.Enumeration;

import javax.naming.NamingException;

import com.novell.service.jncp.NSIException;

import com.novell.service.nds.NdsNCPServer;
import com.novell.service.nds.naming.NdsEnvironment;
import com.novell.service.nds.naming.NdsDirContextWrappable;
import com.novell.service.nds.naming.Schema;


/** @internal
 *
 */
public class NCPServerDirContext
   extends NdsDirContext
   implements NdsNCPServer, Serializable
{
   protected static String baseClass = Schema.NCP_SERVER;

   /**
    *
    */
   protected NCPServerDirContext (
         NdsDirContextWrappable impl,
         NdsEnvironment environment)
      throws NamingException
   {
      super (impl, environment);
   }


   // ******************** NdsNCPServer Interface ********************

   /**
    *
    */
   public void reloadDS ()
      throws NSIException
   {
      ((NdsNCPServer) impl).reloadDS ();
   }

   /**
    *
    */
   public Enumeration listPartitions ()
      throws NSIException
   {
      return (((NdsNCPServer) impl).listPartitions ());
   }

   /**
    *
    */
   public Date getUTCTime ()
      throws NSIException
   {
      return (((NdsNCPServer) impl).getUTCTime ());
   }


   // ******************** NdsObject Interface ********************

   /**
    *
    */
   public String getBaseClass ()
      throws NSIException
   {
      return (baseClass);
   }

}  /* NCPServerDirContext */


